precision mediump float;

varying lowp vec4 v_TexCoordOut;
uniform sampler2D u_Texture;
uniform float u_Alpha;
uniform float u_Fuse;
uniform float u_Size;

void main() {
    float PI=3.141592;

    vec2 tex = 2.0 * v_TexCoordOut.xy - vec2(0.5, 0.5);
    vec2 pos = 2.0 * v_TexCoordOut.xy - vec2(1.0, 1.0);
    float angle = (atan(pos.y, pos.x) + PI) / (2.0*PI);
    float dist = sqrt(dot(pos, pos));

    float border = 0.05;
    float thick = 0.1;

    float x = 1.0 - step(u_Fuse, angle);
    x = x - smoothstep(1.0 - border,1.0, dist);
    x = x - (1.0 - smoothstep(1.0-thick-border, 1.0-thick, dist));
    x = clamp(x, 0.0, 1.0);
    x = x + (1.0 - smoothstep(u_Size-border,u_Size, dist));
    x = x - (1.0 - smoothstep(u_Size-thick-border,u_Size-thick, dist));

    gl_FragColor = vec4(x, x, x, x * u_Alpha);// + u_Alpha * texture2D(u_Texture, tex);

    //gl_FragColor = texture2D(u_Texture, tex);
}