precision mediump float;

uniform float u_Ratio;
varying lowp vec4 v_TexCoordOut;
uniform vec4 u_Color;


void main( void )
{
    vec2 uv1 = v_TexCoordOut.xy;
    float ratio = u_Ratio;

    vec2 uv = vec2(uv1.x, uv1.y/ratio);

    vec2 r = vec2(.1, .1);

    float c=.0;
    c = 1. - step(r.x, distance(uv,r));

    float d = distance(uv, vec2(1.,1./ratio)-r);
    c += 1. - step(r.x, d);

    d = distance(uv, vec2(1. - r.x, 0. + r.y));
    c += 1. - step(r.x, d);

    d = distance(uv, vec2(r.x, 1./ratio - r.y));
    c += 1. - step(r.x, d);

    c += step(r.x, uv.x) - step(1. - r.x, uv.x);

    c += step(r.y, uv.y) - step(1./ratio-r.y, uv.y);

    c = clamp(c, 0., 1.);

	gl_FragColor = vec4( c*u_Color );
}
