#extension GL_OES_EGL_image_external : require
precision highp float;

uniform lowp samplerExternalOES texture;
uniform lowp vec4 textureOffsets;
uniform vec4 unViewport;
uniform vec3 unCorners[5];
uniform float domesize;

#define PIP2    1.5707963       // PI/2
#define PI      3.1415629
#define TWOPI   6.2831853       // 2PI


//    float DOMESCALE_180 = 1.0f;
//    float DOMESCALE_220 = 1.2222f;
//    float DOMESCALE_270 = 1.5f;
//    float DOMESCALE_360 = 2.0f;

float fasin(float x)
{
    return x + x * x * x * x * x * .4971;
}

vec4 render(vec3 ro, vec3 rd)
{

    float x = (atan(rd.x, -rd.z) + PI) / TWOPI; // x = [0,1]
    float s = 2.0/domesize;
    x = s*x - (s - 1.0)/2.0;
    float y = (asin(rd.y) + PIP2) / PI;
    vec2 uv = vec2(x*textureOffsets.y + textureOffsets.x*textureOffsets.y,
                   (1.0 - y)*textureOffsets.w + textureOffsets.z*textureOffsets.w);
    uv = min(uv,1.0);
    uv = max(uv,0.0);
    return texture2D(texture, uv);
}

void main(void)
{
    lowp vec3 ro = unCorners[4];
    lowp vec2 uv = (gl_FragCoord.xy - unViewport.xy)/unViewport.zw;
    lowp vec3 rd = normalize( mix( mix( unCorners[0], unCorners[1], uv.x ),
                              mix( unCorners[3], unCorners[2], uv.x ),
                              uv.y ) - ro);

   	gl_FragColor = render(ro, rd);
}