#extension GL_OES_EGL_image_external : require
precision highp float;

uniform lowp samplerExternalOES texture;
uniform lowp vec4 textureOffsets;
uniform vec4 unViewport;
uniform vec3 unCorners[5];

vec4 render(vec3 ro, vec3 rd)
{
    // rd.xy is -1 to 1
    vec2 ab = rd.xy/2.0 + vec2(.5,.5);
    // ab is 0 to 1

    vec2 uv = vec2(ab.x*textureOffsets.y + textureOffsets.x*textureOffsets.y,
                   1.0 - (ab.y*textureOffsets.w + textureOffsets.z*textureOffsets.w));

    return texture2D(texture, uv);
}

void main(void)
{
    lowp vec3 ro = unCorners[4];
    lowp vec2 uv = (gl_FragCoord.xy - unViewport.xy)/unViewport.zw;
    lowp vec3 rd = normalize( mix( mix( unCorners[0], unCorners[1], uv.x ),
                              mix( unCorners[3], unCorners[2], uv.x ),
                              uv.y ) - ro);

   	gl_FragColor = render(ro, rd);
}