#extension GL_OES_EGL_image_external : require
precision highp float;
varying vec4 v_Color;

varying vec4 v_TexCoordOut;
uniform samplerExternalOES u_Texture;
uniform float u_gamma;
uniform float u_saturation;
uniform float u_cropy;

vec3 gamma(vec3 color, float g) {
    return pow(color, vec3(1./g));
}

vec3 saturation(vec3 color, float s) {
    return mix(vec3(dot(color, vec3(.3,.6,.1))), color, vec3(s));
}

vec4 filter(vec4 col, float g, float s) {
    return vec4(gamma(saturation(col.xyz, s), g), col.w);
}

void main() {
//    vec4 c = texture2D(u_Texture, vec2(v_TexCoordOut.x/v_TexCoordOut.w, v_TexCoordOut.y));
    vec4 c = texture2D(u_Texture, vec2(v_TexCoordOut.x/v_TexCoordOut.w, v_TexCoordOut.y*(1.0-u_cropy) + u_cropy/2.0));

    gl_FragColor = filter(c, u_gamma, u_saturation);
}
